void SetEffectSource(char** Vals, void* TargetStruct, void* TempStruct, int Number, bool header)
{
	static int name, weapon, armor, shield, helmet, ring, amulet, gloves, boots, belt, cloak, fight, magic, shadow, multi, cost, cost2, valcount;
	static int scriptpos, skillboostpos, variablepos, rangedpos, clericpos;
	
	if (header)
	{
		name = GetValNumber(Vals, "Effect", Number);
		weapon = GetValNumber(Vals, "Weapon", Number);
		armor = GetValNumber(Vals, "Armor", Number);
		shield = GetValNumber(Vals, "Shield", Number);
		helmet = GetValNumber(Vals, "Helmet", Number);
		ring = GetValNumber(Vals, "Ring", Number);
		amulet = GetValNumber(Vals, "Amulet", Number);
		gloves = GetValNumber(Vals, "Gloves", Number);
		boots = GetValNumber(Vals, "Boots", Number);
		belt = GetValNumber(Vals, "Belt", Number);
		cloak = GetValNumber(Vals, "Cloak", Number);
		fight = GetValNumber(Vals, "Fight", Number);
		magic = GetValNumber(Vals, "Mage", Number);
		shadow = GetValNumber(Vals, "Shadow", Number);
		clericpos = GetValNumber(Vals, "Cleric", Number);
		multi = GetValNumber(Vals, "Multi", Number);
		cost = GetValNumber(Vals, "Cost", Number);
		cost2 = GetValNumber(Vals, "Cost2", Number);
		scriptpos = GetValNumber(Vals, "EffectScript", Number);
		skillboostpos = GetValNumber(Vals, "SkillBoost", Number);
		variablepos = GetValNumber(Vals, "Variable", Number);
		rangedpos = GetValNumber(Vals, "Ranged", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in EffectSource Database (%s)\n", Vals[0]);
		quitprog();
	}
	
	((clsEffectSource*) TargetStruct)->Name = Vals[name];
	((clsEffectSource*) TargetStruct)->Weapon = atoi(Vals[weapon]);
	((clsEffectSource*) TargetStruct)->Armor = atoi(Vals[armor]);
	((clsEffectSource*) TargetStruct)->Shield = atoi(Vals[shield]);
	((clsEffectSource*) TargetStruct)->Helmet = atoi(Vals[helmet]);
	((clsEffectSource*) TargetStruct)->Ring = atoi(Vals[ring]);
	((clsEffectSource*) TargetStruct)->Amulet = atoi(Vals[amulet]);
	((clsEffectSource*) TargetStruct)->Gloves = atoi(Vals[gloves]);
	((clsEffectSource*) TargetStruct)->Boots = atoi(Vals[boots]);
	((clsEffectSource*) TargetStruct)->Belt = atoi(Vals[belt]);
	((clsEffectSource*) TargetStruct)->Cloak = atoi(Vals[cloak]);
	((clsEffectSource*) TargetStruct)->Fight = atoi(Vals[fight]);
	((clsEffectSource*) TargetStruct)->Magic = atoi(Vals[magic]);
	((clsEffectSource*) TargetStruct)->Shadow = atoi(Vals[shadow]);
	((clsEffectSource*) TargetStruct)->Divine = atoi(Vals[clericpos]);
	((clsEffectSource*) TargetStruct)->Multi = atoi(Vals[multi]);
	((clsEffectSource*) TargetStruct)->Cost = atoi(Vals[cost]);
	((clsEffectSource*) TargetStruct)->Cost2 = atoi(Vals[cost2]);

	((clsEffectSource*) TargetStruct)->Ranged = atoi(Vals[rangedpos]);

	((clsTempEffectSource*) TempStruct)->SkillBoost = Vals[skillboostpos];
	str_replace(',', ' ', ((clsTempEffectSource*) TempStruct)->SkillBoost.buffer);
	str_replace(';', 0, ((clsTempEffectSource*) TempStruct)->SkillBoost.buffer);
	
	if (bnf::bnfparse(Vals[scriptpos], &(((clsEffectSource*) TargetStruct)->Script)) ||
		bnf::bnfparse(Vals[variablepos], &(((clsEffectSource*) TargetStruct)->Variable)))
	{
		printf("Error in Effect Script %s\n", Vals[name]);
		quitprog();
	}
}

void EffectSourceExit()
{
	int i;
	for (i = 0;i < Source.EffectSourceCount;i++)
	{
		freel(Source.EffectSource[i].Script);
		freel(Source.EffectSource[i].Variable);
	}
	delete[] Source.EffectSource;
}
