void SetMonsterSource(char** Vals, void* TargetStruct, void* TempStruct, int Number, bool header)
{
	int i;

	static int name, cr, type, size, epic, hd, hdtype, tp, rwref, rwwil, rwzaeh, attr[6];
	static int ac, hdmin, hdmax, hdinc, hdinc2, init, speed, orgmin, orgmax, mix, treasure;
	static int att[6], num[6], red[6], dmga[6], dmgb[6], dmgc[6], atype[6], altern[2], feats[6], skills[7], skilll[7];
	static int spellcharpos, clericspellpos, familiarpos, abbilitypos;
	static int valcount;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		cr = GetValNumber(Vals, "CR", Number);
		type = GetValNumber(Vals, "Type", Number);
		size = GetValNumber(Vals, "Size", Number);
		epic = GetValNumber(Vals, "Epic", Number);
		hd = GetValNumber(Vals, "HD", Number);
		hdtype = GetValNumber(Vals, "HDT", Number);
		tp = GetValNumber(Vals, "TP", Number);
		rwref = GetValNumber(Vals, "Ref", Number);
		rwwil = GetValNumber(Vals, "Wil", Number);
		rwzaeh = GetValNumber(Vals, "Zaeh", Number);
		for (i = 0;i < 6;i++)
		{
			attr[i] = GetValNumber(Vals, GetAttributeName(i), Number);
		}

		ac = GetValNumber(Vals, "AC", Number);
		hdmin = GetValNumber(Vals, "HDMin", Number);
		hdmax = GetValNumber(Vals, "HDMax", Number);
		hdinc = GetValNumber(Vals, "HDInc", Number);
		hdinc2 = GetValNumber(Vals, "HDInc2", Number);
		init = GetValNumber(Vals, "Init", Number);
		speed = GetValNumber(Vals, "Speed", Number);
		orgmin = GetValNumber(Vals, "OrgMin", Number);
		orgmax = GetValNumber(Vals, "OrgMax", Number);
		mix = GetValNumber(Vals, "Mixed", Number);
		treasure = GetValNumber(Vals, "Treasur", Number);

		spellcharpos = GetValNumber(Vals, "SpellChar", Number);
		clericspellpos = GetValNumber(Vals, "ClericSpells", Number);
		familiarpos = GetValNumber(Vals, "Familiar", Number);
		abbilitypos = GetValNumber(Vals, "Abbilities", Number);

		for (i = 0;i < 6;i++)
		{
			sprintf(tempout, "Attack%d", i + 1);
			att[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Number%d", i + 1);
			num[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "AttRed%d", i + 1);
			red[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Dmg%dA", i + 1);
			dmga[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Dmg%dB", i + 1);
			dmgb[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Dmg%dC", i + 1);
			dmgc[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Type%d", i + 1);
			atype[i] = GetValNumber(Vals, tempout, Number);
			if (i < 2) 
			{
				sprintf(tempout, "Altern%d", i + 1);
				altern[i] = GetValNumber(Vals, tempout, Number);
			}
			sprintf(tempout, "Feat%d", i + 1);
			feats[i] = GetValNumber(Vals, tempout, Number);
		}
		for (i = 0;i < 7;i++)
		{
			sprintf(tempout, "Skill%d", i + 1);
			skills[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "SkillL%d", i + 1);
			skilll[i] = GetValNumber(Vals, tempout, Number);
		}
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in MonsterSource Database (%s)\n", Vals[0]);
		quitprog();
	}

	if (atoi(Vals[hdmin]) > 0 && atoi(Vals[hdmin]) < atoi(Vals[hd]))
	{
		printf("HDMin < HD: %s: %d < %d\n", Vals[name], atoi(Vals[hdmin]), atoi(Vals[hd]));
		quitprog();
	}

	((clsMonsterSource*) TargetStruct)->Name = Vals[name];

	FILE* fChkMonsterDesc;
	sprintf(tempout, "Build\\MonsterText\\%s", Vals[name]);
	fChkMonsterDesc = fopen(tempout, "r");
	if (fChkMonsterDesc == 0) {
		printf("Monster Description not found%s\n", Vals[name]);
		quitprog();
	} else {
		fclose(fChkMonsterDesc);
	}


	((clsMonsterSource*) TargetStruct)->CR = atoi(Vals[cr]);

	((clsMonsterSource*) TargetStruct)->Type = GetMonsterTypeNumber(Vals[type]);
	((clsMonsterSource*) TargetStruct)->Size = GetSizeNumber(Vals[size]);

	((clsMonsterSource*) TargetStruct)->Epic = atoi(Vals[epic]);
	((clsMonsterSource*) TargetStruct)->HD = atoi(Vals[hd]);
	((clsMonsterSource*) TargetStruct)->HDType = atoi(Vals[hdtype]);
	((clsMonsterSource*) TargetStruct)->TPBonus = atoi(Vals[tp]);
	((clsMonsterSource*) TargetStruct)->RWRef = atoi(Vals[rwref]);
	((clsMonsterSource*) TargetStruct)->RWWil = atoi(Vals[rwwil]);
	((clsMonsterSource*) TargetStruct)->RWZaeh = atoi(Vals[rwzaeh]);
	for (i = 0;i < 6;i++)
	{
		((clsMonsterSource*) TargetStruct)->Attr[i] = atoi(Vals[attr[i]]);
	}

	((clsMonsterSource*) TargetStruct)->AC = atoi(Vals[ac]);
	((clsMonsterSource*) TargetStruct)->HDMin = atoi(Vals[hdmin]);
	((clsMonsterSource*) TargetStruct)->HDMax = atoi(Vals[hdmax]);
	((clsMonsterSource*) TargetStruct)->HDInc = atoi(Vals[hdinc]);
	((clsMonsterSource*) TargetStruct)->HDInc2 = atoi(Vals[hdinc2]);
	((clsMonsterSource*) TargetStruct)->Init = atoi(Vals[init]);
	((clsMonsterSource*) TargetStruct)->Speed = atoi(Vals[speed]);
	((clsMonsterSource*) TargetStruct)->OrgMin = atoi(Vals[orgmin]);
	((clsMonsterSource*) TargetStruct)->OrgMax = atoi(Vals[orgmax]);
	((clsMonsterSource*) TargetStruct)->Mixed = atoi(Vals[mix]);
	((clsMonsterSource*) TargetStruct)->Treasure = atoi(Vals[treasure]);

	((clsMonsterSource*) TargetStruct)->SpellChar = (char*) mallocl(strlen(Vals[spellcharpos]) + 1, "SetMonsterSource-SpellChar");
	strcpy(((clsMonsterSource*) TargetStruct)->SpellChar, Vals[spellcharpos]);
	str_replace(':', ' ', ((clsMonsterSource*) TargetStruct)->SpellChar);
	str_replace(';', 0, ((clsMonsterSource*) TargetStruct)->SpellChar);

	((clsTempMonsterSource*) TempStruct)->Abbilities = Vals[abbilitypos];
	str_replace(';', 0, ((clsTempMonsterSource*) TempStruct)->Abbilities.buffer);

	((clsMonsterSource*) TargetStruct)->ClericSpells = atoi(Vals[clericspellpos]);

	for (i = 0;i < 6;i++)
	{
		if (Vals[atype[i]][0] == 48)
		{
			break;
		}
		((clsMonsterSource*) TargetStruct)->AttackBonus[i] = atoi(Vals[att[i]]);
		((clsMonsterSource*) TargetStruct)->AttackNumber[i] = atoi(Vals[num[i]]);
		((clsMonsterSource*) TargetStruct)->AttackRed[i] = atoi(Vals[red[i]]);
		((clsMonsterSource*) TargetStruct)->DamageA[i] = atoi(Vals[dmga[i]]);
		((clsMonsterSource*) TargetStruct)->DamageB[i] = atoi(Vals[dmgb[i]]);
		((clsMonsterSource*) TargetStruct)->DamageC[i] = atoi(Vals[dmgc[i]]);
		((clsMonsterSource*) TargetStruct)->AttackType[i] = Vals[atype[i]];

		if (i < 2) 
		{
			((clsMonsterSource*) TargetStruct)->AlternateAttack[i] = atoi(Vals[altern[i]]);
		}
		else if (strcmp(Vals[atype[i]], "Slap") == 0)
		{
			((clsMonsterSource*) TargetStruct)->AlternateAttack[i] = 3;
		}
		else
		{
			((clsMonsterSource*) TargetStruct)->AlternateAttack[i] = 0;
		}
	}
	((clsMonsterSource*) TargetStruct)->AttackCount = i;
	for (i = 0;i < 6;i++)
	{
		if (Vals[feats[i]][0] == 48)
		{
			break;
		}
		((clsMonsterSource*) TargetStruct)->Feats[i] = GetFeatNumber(Vals[feats[i]], 1);
	}
	((clsMonsterSource*) TargetStruct)->FeatCount = i;
	for (i = 0;i < 7;i++)
	{
		if (Vals[skills[i]][0] == 48)
		{
			break;
		}
		((clsMonsterSource*) TargetStruct)->Skills[i] = GetSkillNumber(Vals[skills[i]], 1);
		((clsMonsterSource*) TargetStruct)->SkillLevels[i] = atoi(Vals[skilll[i]]);
	}
	((clsMonsterSource*) TargetStruct)->SkillCount = i;

	if (bnf::bnfparse(Vals[familiarpos], &(((clsMonsterSource*) TargetStruct)->Familiar)))
	{
		printf("Error in Monster Familiar Script %s\n", Vals[name]);
		quitprog();
	}
}

void MonsterSourceExit()
{
	int i;
	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		freel(Source.MonsterSource[i].SpellChar);
		freel(Source.MonsterSource[i].Familiar);
	}
	delete[] Source.MonsterSource;
	freel(Source.MonsterCR);
}

void DoMonsterDesc(basestring& Desc, char* FileName)
{
	List<clsMonsterDescSource>* CurDesc = TempSource.MonsterDesc;

	ucase(FileName);

	while (CurDesc)
	{
		if (CurDesc->FileName == FileName)
		{
			Desc = CurDesc->Content.buffer;
			return;
		}
		CurDesc = CurDesc->NextElem;
	}
	printf("Could not Find Text for Monster\n");
	quitprog();
}

void DoMonsterDesc2(string* strText, char* FileName)
{
	FILE* fMonster;
	int i;
	char* buffer;
	char* buffertest;
	char* IncludeFile;
	fMonster = fopen(FileName, "r");
	if (fMonster == 0)
	{
		printf("Error opening File %s\n", FileName);
		quitprog();
	}

	fseek(fMonster, 0, SEEK_END);
	buffer = (char*) mallocl(ftell(fMonster) + 1, "DoMonsterDesc-buffer");
	fseek(fMonster, 0, SEEK_SET);

	while (!feof(fMonster))
	{
		buffer[0] = 0;
		fgets(buffer, 8191, fMonster);
		for (i = 0;i < (signed) strlen(buffer);i++)
		{
			if (buffer[i] == 13 || buffer[i] == 10)
			{
				buffer[i] = 0;
			}
		}

		buffertest = (char*) mallocl(strlen(buffer) + 1, "DoMonsterDesc-buffertest");
		strncpy(buffertest, buffer, strlen("include"));
		buffertest[strlen("include")] = 0;
		if (strcmp(buffertest, "include") == 0)
		{
			sscanf(buffer, "include %s", buffertest);
			IncludeFile = (char*) mallocl(strlen(buffertest) + 20, "DoMonsterDesc-IncludeFile");
			sprintf(IncludeFile, "Build\\MonsterText\\%s", buffertest);
			DoMonsterDesc2(strText, IncludeFile);
			freel(IncludeFile);
		}
		else
		{
			*strText += buffer;
			if (strlen(buffer) == 0)
			{
				*strText += "\n";
			}
			else
			{
				*strText += " ";
			}
		}
		freel(buffertest);
	}
	*strText += "\n";

	freel(buffer);

	fclose(fMonster);
}

void FinishMonsterDesc()
{
	int i;
	string tmpStr;
	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		tmpStr = "Build\\MONSTERTEXT\\";
		tmpStr += Source.MonsterSource[i].Name;
		DoMonsterDesc(Source.MonsterSource[i].MonsterDesc, tmpStr.buffer);
	}
	for (i = 0;i < Source.TemplateSourceCount;i++)
	{
		tmpStr = "Build\\MONSTERTEXT\\";
		tmpStr += Source.TemplateSource[i].Name;
		DoMonsterDesc(Source.TemplateSource[i].TemplateDesc, tmpStr.buffer);
	}
}

void InitMonsterDesc()
{
	WIN32_FIND_DATA FindFileData;
	HANDLE hSearch;

	List<clsMonsterDescSource>** CurDesc = &TempSource.MonsterDesc;

	hSearch = FindFirstFile("Build\\MonsterText\\*.*", &FindFileData);
	if (hSearch != INVALID_HANDLE_VALUE)
	{
		do
		{
			if (FindFileData.cFileName[0] != '.')
			{
				SetNewIdent("InitMonsterDesc-CurDesc");
				*CurDesc = new List<clsMonsterDescSource>;

				(*CurDesc)->FileName = "Build\\MonsterText\\";
				(*CurDesc)->FileName += FindFileData.cFileName;
				ucase((*CurDesc)->FileName);
				DoMonsterDesc2(&(*CurDesc)->Content, (*CurDesc)->FileName.buffer);
				CurDesc = &(*CurDesc)->NextElem;
			}
		} while (FindNextFile(hSearch, &FindFileData));
		FindClose(hSearch);
	}
	FinishMonsterDesc();
	delete TempSource.MonsterDesc;
}