void SetSpecificSource(char** Vals, void* TargetStruct, void* TempStruct, int Number, bool header)
{
	static int valcount, namepos, onpos, scriptpos, pricepos, skillpos, fightpos, magepos, shadowpos, divinepos;

	if (header)
	{
		namepos = GetValNumber(Vals, "Name", Number);
		onpos = GetValNumber(Vals, "On", Number);
		scriptpos = GetValNumber(Vals, "Script", Number);
		pricepos = GetValNumber(Vals, "Price", Number);
		skillpos = GetValNumber(Vals, "SkillBoost", Number);
		fightpos = GetValNumber(Vals, "Fight", Number);
		magepos = GetValNumber(Vals, "Mage", Number);
		shadowpos = GetValNumber(Vals, "Shadow", Number);
		divinepos = GetValNumber(Vals, "Divine", Number);

		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in SpecificSource Database (%s)\n", Vals[0]);
		quitprog();
	}

	((clsSpecificSource*) TargetStruct)->Name = Vals[namepos];
	((clsSpecificSource*) TargetStruct)->On = GetEquipNumber(Vals[onpos]);
	((clsSpecificSource*) TargetStruct)->Price = atoi(Vals[pricepos]);

	((clsSpecificSource*) TargetStruct)->Fight = atoi(Vals[fightpos]);
	((clsSpecificSource*) TargetStruct)->Mage = atoi(Vals[magepos]);
	((clsSpecificSource*) TargetStruct)->Shadow = atoi(Vals[shadowpos]);
	((clsSpecificSource*) TargetStruct)->Divine = atoi(Vals[divinepos]);

	((clsTempSpecificSource*) TempStruct)->SkillBoost = Vals[skillpos];
	str_replace(',', ' ', ((clsTempSpecificSource*) TempStruct)->SkillBoost.buffer);
	str_replace(';', 0, ((clsTempSpecificSource*) TempStruct)->SkillBoost.buffer);

	if (bnf::bnfparse(Vals[scriptpos], &(((clsSpecificSource*) TargetStruct)->script)))
	{
		printf("Error in Specific Script %s\n", Vals[namepos]);
		quitprog();
	}

}

void SpecificSourceExit()
{
	int i;
	{
		for (i = 0;i < Source.SpecificSourceCount;i++)
		{
			freel(Source.SpecificSource[i].script);
		}
	}
	delete[] Source.SpecificSource;
}
