#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include <winbase.h>

#include "defines.h"
#include "malloclog.h"
#include "include/cpuid.h"
#include "global.h"
#include "include/string.h"
#include "include/classes.h"
#include "include/realloc.h"

//Exports
#ifdef STRING_KEEP_ALLOC_LOG
int stringKeepAllocTry = 0;
int stringKeepAllocWorked = 0;
#endif

extern "C" clsSource Source;
extern "C" clsTempSource TempSource;
clsSource Source;

#ifdef INCLUDE_REBUILD
clsTempSource TempSource;
#endif

extern "C" CharTemplate CTtmp;
extern "C" clsChar cDumpChar;
extern "C" clsEquip eDumpEquip;
CharTemplate CTtmp;
clsChar cDumpChar;
clsEquip eDumpEquip;

char* extFuncs;
char* extSymbols;

unsigned long seed[512];
int IsaacRun;

int Moneys[100];
char FullTables[100][BUFFER_LEN];
char FullTable[BUFFER_LEN];
int TPPos[101];
int TPLeft[101];

char refname[SMALL_BUFFER_LEN]; 

int MustRebuild;
int Rebuilded = 0;
int ReserveHigh = 0;
int dwPageSize;

int TestScript = 0;
int ThrowTestExeption = 0;
int RuntimeChoosen = 0;

extern "C" CharTemplate ReHeaderSave;
bool UseReHeaderSave = false;
CharTemplate ReHeaderSave;

bool fConsistenceCheck = false;
bool fConsistenceClean = false;
extern "C" basestring* strConsistenceCheck;
basestring* strConsistenceCheck;

unsigned char Colour[125];

int useagain[USE_AGAIN];
int useagainaddr[USE_AGAIN];

__int64 qwFreq;

int DebugOutput;
int AllocOutput = 0;

int CompactSourceAllocated = 0;

char tempstring[SMALL_BUFFER_LEN];
char tempout[BUFFER_LEN];
char tempout2[BUFFER_LEN];
char tempout3[BUFFER_LEN];
char tempout4[BUFFER_LEN];

bool NoScriptVarSet;

extern "C" void* mallocLogATemp;
void* mallocLogATemp;

extern "C" char* SymbolNames;
char* SymbolNames;

#ifdef BUILD_VS_NET
	namespace vcnetspace
	{
		extern int __cdecl dndmain(int argc, char** argv);
	}
#endif

#ifdef BUILD_DEBUG
	namespace debugspace
	{
		extern int __cdecl dndmain(int argc, char** argv);
	}
#endif

#ifdef BUILD_INTEL
	namespace intelspace
	{
		extern int __cdecl dndmain(int argc, char** argv);
	}
#endif

#ifdef BUILD_VECTORC
	namespace vectorcspace
	{
		extern int __cdecl dndmain(int argc, char** argv);
	}
#endif

#ifdef BUILD_GCC
	extern "C" void __stdcall _Z14if_gcc_dndmaini(int dump);
#endif

#ifdef buildbcc
	namespace bccspace
	{
		extern int __cdecl dndmain(int argc, char** argv);
	}
#endif

int Runtime(int Num, int argc, char** argv)
{
	int Start = Num;
	int restarted = 0;

	goto skiprestart;

restart:
	restarted = 1;
	Num++;
	Num %= 5;

	if (Num == Start)
	{
		printf("No suitable Runtime found\n");
		getchar();
		return(1);
	}

skiprestart:

	if (Num == 0)
	{
#ifdef BUILD_DEBUG
		if (fConsistenceCheck == false)
		{
			printf("\nRunning Debug Code\n");
		}
		return(debugspace::dndmain(argc, argv));
#else
		if (fConsistenceCheck == false)
		{
			printf("Debug Runtime not included, Trying another\n");
		}
		goto restart;
#endif
	}

	if (Num == 1)
	{
#ifdef BUILD_INTEL
		if (fConsistenceCheck == false)
		{
			printf("\nRunning Intel Compiler Prescott Optimized Code\n");
		}
		if (HasSSE3() == false)
		{
			printf("WARNING, NO SSE3 Capable CPU Found\n");
			if (restarted)
			{
				goto restart;
			}
		}
		return(intelspace::dndmain(argc, argv));
#else
		if (fConsistenceCheck == false)
		{
			printf("Intel Compiler Runtime not included, Trying another\n");
		}
		goto restart;
#endif
	}

	if (Num == 2)
	{
#ifdef BUILD_VECTORC
		if (fConsistenceCheck == false)
		{
			printf("\nRunning VectorC Compiler Optimized Code\n");
		}
		if (HasSSE2() == false)
		{
			printf("WARNING, NO SSE2 Capable FOUND\n");
			if (restarted)
			{
				goto restart;
			}
		}
		return(vectorcspace::dndmain(argc, argv));
#else
		if (fConsistenceCheck == false)
		{
			printf("VectorC Runtime not included, Trying another\n");
		}
		goto restart;
#endif
	}

	if (Num == 3)
	{
#ifdef BUILD_GCC
		if (fConsistenceCheck == false)
		{
			printf("\nRunning GCC Compiler SSE3 Optimized Code\n");
		}
		if (HasSSE3() == false)
		{
			printf("WARNING, NO SSE3 Capable CPU Found\n");
			if (restarted)
			{
				goto restart;
			}
		}
		_Z14if_gcc_dndmaini(0);
		return(0);
#else
		if (fConsistenceCheck == false)
		{
			printf("GCC Runtime not included, Trying another\n");
		}
		goto restart;
#endif
	}

	if (Num == 4)
	{
#ifdef BUILD_VS_NET
		if (fConsistenceCheck == false)
		{
			printf("Running Visual C++ .NET Compiler Optimized Code\n");
		}
		return(vcnetspace::dndmain(argc, argv));
#else
		if (fConsistenceCheck == false)
		{
			printf("Visual C++ .NET Runtime not included, Trying another\n");
		}
		goto restart;
#endif
	}

	printf("Unknown Runtime\nExiting...\n");
	getchar();
	return(1);
}

int CheckSaveDir()
{
	WIN32_FIND_DATA FindData;
	HANDLE hFindFile;

	hFindFile = FindFirstFile("save", &FindData);

	if (hFindFile != INVALID_HANDLE_VALUE)
	{
		FindClose(hFindFile);
		if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
		{
			return(0);
		}
	}

	return(!CreateDirectory("save", NULL));
}

#ifdef ALLOW_FLOAT_TEST
namespace debugspace {double __cdecl CheckFloat(double val);}
namespace intelspace {double __cdecl CheckFloat(double val);}
namespace vectorcspace {double __cdecl CheckFloat(double val);}
namespace gccspace {extern "C" double __cdecl if_gcc_CheckFloat(double val);}
namespace vcnetspace {double __cdecl CheckFloat(double val);}
int CheckFloatConsistence()
{
#if (ALLOW_FLOAT_TEST == 2)
	printf("Checking Float Consistence\n");
#endif
	double valdebug, valintel, valvectorc, valgcc, valvcnet;

	valdebug = debugspace::CheckFloat(10);

	if (HasSSE3())
	{
		valintel = intelspace::CheckFloat(10);
		valgcc = gccspace::if_gcc_CheckFloat(10);
	}
	else
	{
		printf("Skipping Intel Compiler and GCC as not SSE3 support was found\n");
		valintel = valdebug;
		valgcc = valdebug;
	}

	if (HasSSE2())
	{
		valvectorc = vectorcspace::CheckFloat(10);
	}
	else
	{
		printf("Skipping VectorC as no SSE2 Support was found\n");
		valvectorc = valdebug;
	}
	valvcnet = vcnetspace::CheckFloat(10);

	if (valdebug != valintel || valdebug != valvectorc || valdebug != valgcc || valdebug != valvcnet)
	{
		printf("Float not consistent between Compilers !!!\n");
		printf("Reproduce might not work correctly !!!\n");
		printf("Press a key to continue\n");
		fflush(stdin);
		getch();
	}
#if (ALLOW_FLOAT_TEST == 2)
	else
	{
		printf("Float consistent\n");
	}
#endif

	return(0);
}
#endif

int main(int argc, char** argv)
{
	int StdRun;
	int RetVal, RetVal2 = 0;

	SYSTEM_INFO sSysInfo;
	GetSystemInfo(&sSysInfo);
	dwPageSize = sSysInfo.dwPageSize;

	printf("DND Chargen V. 1.0.3.1 (Build %d) Coded by qon in 2k5\n\n",
#include "build"
		);

#ifdef ALLOW_FLOAT_TEST
	CheckFloatConsistence();
#endif

	if (CheckSaveDir())
	{
		printf("Cannot Create Save Directory\n");
		RetVal = 1;
		goto mainend;
	}
	QueryPerformanceFrequency((LARGE_INTEGER*) &qwFreq);

#ifdef DUMP_SOURCE_LOAD
	if (MustRebuild = ReAlloc("source.dnd", &Source, sizeof(clsSource), &bnf::SymbolNames, 0))
	{
		printf("will rebuild later...\n\n");
	}
#else
	MustRebuild = 1;
#endif

#ifndef INCLUDE_REBUILD
	if (MustRebuild)
	{
		RetVal = 1;
		goto mainend;
	}
#endif

	if (argc == 2)
	{
		StdRun = atoi(argv[1]);
		printf("Runtime choosen by Argument\n");
	}
	else if (HasSSE3())
	{
		printf("SSE3 capable CPU found, using Intel Compiler Runtime\n\n");
		StdRun = 1;
	}
	else if (isAthlon())
	{
		printf("Athlon CPU found, using VectorC Optimized Runtime\n\n");
		StdRun = 2;
	}
	else
	{
		printf("No SSE or 3DNow capable CPU found, using Microsoft Compiler Generic Runtime\n\n");
		StdRun = 4;
	}

	RetVal = Runtime(StdRun, argc, argv);

	if ((CompactSourceAllocated && (!VirtualFree((void*) VIRTUAL_COMPACT_BASE, 0, MEM_RELEASE))) || RetVal2)
	{
		printf("Failed freeing Memory for some reason, Shouldn't make a difference yet though :|\n\n");
		RetVal = 1;
	}

	ZeroMemory(&Source, sizeof(clsSource));

#ifdef MALLOC_LOG
	ListAlloc();
#endif

#ifdef STRING_KEEP_ALLOC_LOG
	printf("String Optimization Result: %d of %d reallocations avoided\nPress a key to continue\n", stringKeepAllocWorked, stringKeepAllocTry);
	fflush(stdin);
	getchar();
#endif

mainend:
	while (kbhit()) {getch();}
	fflush(stdin);
	if (RetVal)
	{
		printf("Aborting...\n");
		getchar();
	}
	else
	{
		printf("\nExiting...\n");
	}
	return(RetVal);
}

int __cdecl breakpoint(char* Text)
{
	throw(Text);
	return(0);
}